#pragma once
#include "SFML/Graphics.hpp"

namespace config {
    // Общее:
    const unsigned int FRAME_RATE_LIMIT = 60;
    // Меню:
    const sf::Vector2f BUTTON_SIZE = { 250, 100 };
    const size_t BUTTON_FONT_SIZE = static_cast<size_t>(BUTTON_SIZE.y / 1.5f); const float BUTTON_FRAME_THICKNESS = 2.0f;
    const char FONT_FILE[] = "Calibri.ttf";
    const char SELECT_LEVEL_TITLE_WINDOW[] = "Settings";
    const char SELECT_LEVEL_TITLE[] = "Select Level:";
    const char SELECT_LEVEL_TITLE_PLAYER[] = "Select Player:";
    const char SELECT_THEME[] = "Select Theme:";
    const char BUTTON_THEME_WHITE[] = "Theme: White";
    const char BUTTON_THEME_BLACK[] = "Theme: Black";
    const sf::VideoMode SELECT_LEVEL_VIDEO_MODE{ 1138, 620 };
    const std::vector<std::string> BUTTON_TEXT = {"Easy","Medium", "Hard", "Exit"};
    const char BUTTON_TEXT_EASY[] = "Easy";
    const char BUTTON_TEXT_MEDIUM[] = "Medium";
    const char BUTTON_TEXT_HARD[] = "Hard";
    const char BUTTON_TEXT_EXIT[] = "Exit";
// Игра:
    const sf::VideoMode GAME_VIDEO_MODE{ 1138, 620 };
    const float MENU_WIDTH = GAME_VIDEO_MODE.width / 4;
    const float SCREEN_HEIGHT = GAME_VIDEO_MODE.height;
    const float GAME_WIDTH = GAME_VIDEO_MODE.width - MENU_WIDTH;
    const char BUTTON_START_GAME[] = "Start Game";
    const char EASY_GAME_TITLE[] = "Level: Easy";
    const char ONE_PLAYER_GAME_TITLE[] = "Player: One";
    const char TWO_PLAYER_GAME_TITLE[] = "Player: Two";
    const char MEDIUM_GAME_TITLE[] = "Level: Medium";
    const char HARD_GAME_TITLE[] = "Level: Hard";
    const float EASY_GAME_ENEMY_RATIO = 0.0f;
    const float MEDIUM_GAME_ENEMY_RATIO = 0.03f;
    const float HARD_GAME_ENEMY_RATIO = 0.07f;
    const float ROOM_SIZE = 50;
    const float GAME_ENEMY_SIZE = ROOM_SIZE * 0.7;
    const float GAME_FOOD_SIZE = ROOM_SIZE * 0.2;
// Пакмэн:
    const float GAME_PACMAN_SIZE = ROOM_SIZE * 0.8;
    const sf::Keyboard::Key KEY_LEFT = sf::Keyboard::A;
    const sf::Keyboard::Key KEY_RIGHT = sf::Keyboard::D;
    const sf::Keyboard::Key KEY_UP = sf::Keyboard::W;
    const sf::Keyboard::Key KEY_DOWN = sf::Keyboard::S;
// Цвета:
    const sf::Color BUTTON_COLOR_TEXT{ 255, 255, 255 };
    const sf::Color BUTTON_COLOR_FILL{ 0, 0, 0 };
    const sf::Color BUTTON_COLOR_SELECTION{ 50, 50, 100 };
    const sf::Color BUTTON_COLOR_FRAME{ 0, 0, 255 };
    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR{ 25,25,25 };
    const sf::Color GAME_COLOR_BACKGROUND_INGAME{ 50,50,50 };
    const sf::Color GAME_COLOR_BACKGROUND_WIN{ 0, 100, 0 };
    const sf::Color GAME_COLOR_BACKGROUND_LOST{ 100, 0, 0 };
    const sf::Color GAME_COLOR_PACMAN{ 250, 250, 0 };
    const sf::Color GAME_COLOR_PACMAN_INVISIBLE  { 250, 250, 0, 128 };
    const sf::Color GAME_COLOR_ROOM{ 0, 0, 0 };
    const sf::Color GAME_COLOR_WALL{ 0, 0, 255 };
    const sf::Color GAME_FOOD_COLOR{ 0, 200, 100 };
    const sf::Color GAME_ENEMY_COLOR{ 255, 50, 0 };
//    const sf::Color BUTTON_COLOR_TEXT{ 0, 0, 0 };
//    const sf::Color BUTTON_COLOR_FILL{ 180, 180, 180 };
//    const sf::Color BUTTON_COLOR_SELECTION{ 255, 180, 180 };
//    const sf::Color BUTTON_COLOR_FRAME{ 0, 0, 0 };
//    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR{ 230,230,230 };
//    const sf::Color GAME_COLOR_BACKGROUND_INGAME{ 230,230,230 };
//    const sf::Color GAME_COLOR_BACKGROUND_WIN{ 0, 255, 0 };
//    const sf::Color GAME_COLOR_BACKGROUND_LOST{ 255, 0, 0 };
//    const sf::Color GAME_COLOR_PACMAN{ 250, 150, 0 };
//    const sf::Color GAME_COLOR_ROOM{ 255, 255, 255 };
//    const sf::Color GAME_COLOR_WALL{ 0, 0, 0 };
//    const sf::Color GAME_FOOD_COLOR{ 0, 200, 100 };
//    const sf::Color GAME_ENEMY_COLOR{ 255, 50, 0 };
}





