#pragma once
# include "../Drawable/Entity/Pacman.h"

#include <istream>
#include <list>

struct GameContext {
    GameContext();
    enum State { INGAME, WIN, LOST } state = INGAME;
    std::list<std::unique_ptr<IDynamicEntity>> dynamic_objects;
    std::list<std::unique_ptr<IStaticEntity>> static_objects;

    Pacman pacman;
    Pacman pacman2;
    GameContext clone();
};


class ContextManager {
public:
    void save_current_context() { m_history.push(m_initial_context.clone()); };
    void restore_previous_context();
    void reset(GameContext&& context);
    GameContext& get_current_context() { return m_initial_context; };
private:
    GameContext m_initial_context;
    std::stack<GameContext> m_history;
};