#pragma once
#include "../../../State/IState.h"
#include "../Button/Button.h"

#include <array>

class Menu : public IDrawable {
public:
    Menu(IStateManager& state_manager);
    void draw_into(sf::RenderWindow& window) override;
    void process_mouse(sf::Vector2f pos, bool is_pressed);

private:
    sf::RectangleShape m_shape;
    std::vector<std::unique_ptr<ChooseButton>> m_choose_button;
    std::vector<std::unique_ptr<ChooseButton>> m_choose_button_players;
    std::vector<std::unique_ptr<ChooseButton>> m_choose_button_theme;
    std::unique_ptr<Button> m_proceed_button;
    std::unique_ptr<Button> m_exit_button;
    std::vector<std::unique_ptr<GameBuilderDirector>> m_directors;
    int m_selected_level = -1;
    int m_selected_players = -1;
    int m_selected_theme = 0;
    IStateManager& m_state_manager;
    std::vector<std::unique_ptr<Button>> m_buttons; //@todo vector changes to array<Button, 4>

};