#include "MyTexture.h"
PacmanTexture::PacmanTexture() {
    if (!m_texture_up.loadFromFile(std::string(ASSETS_PATH) + "pacmanUp.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
    if (!m_texture_down.loadFromFile(std::string(ASSETS_PATH) + "pacmanDown.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
    if (!m_texture_right.loadFromFile(std::string(ASSETS_PATH) + "pacmanRight.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
    if (!m_texture_left.loadFromFile(std::string(ASSETS_PATH) + "pacmanLeft.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
}

PacmanTexture2::PacmanTexture2() {
    if (!m_texture_up.loadFromFile(std::string(ASSETS_PATH) + "pacmanUp2.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
    if (!m_texture_down.loadFromFile(std::string(ASSETS_PATH) + "pacmanDown2.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
    if (!m_texture_right.loadFromFile(std::string(ASSETS_PATH) + "pacmanRight2.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
    if (!m_texture_left.loadFromFile(std::string(ASSETS_PATH) + "pacmanLeft2.png"))
        throw std::runtime_error("Can't added Texture for Pacman");
}
//в зависимости от направления - разные текстуры
sf::Texture& PacmanTexture::get_texture() {
    switch (m_direction) {
        case Direction::UP:
            return m_texture_left;
        case Direction::DOWN:
            return m_texture_right;
        case Direction::RIGHT:
            return m_texture_up;
        case Direction::LEFT:
            return m_texture_down;
    }
}

sf::Texture& PacmanTexture2::get_texture() {
    switch (m_direction) {
        case Direction::UP:
            return m_texture_left;
        case Direction::DOWN:
            return m_texture_right;
        case Direction::RIGHT:
            return m_texture_up;
        case Direction::LEFT:
            return m_texture_down;
    }
}

FoodTexture::FoodTexture() {
    if (!m_texture_food.loadFromFile(std::string(ASSETS_PATH) + "grusha.png"))
        throw std::runtime_error("Can't added Texture for food");
}

EnemyTexture::EnemyTexture() {
    m_texture_enemy.loadFromFile(std::string(ASSETS_PATH) + "enemy.png");
}

BackgroundTexture::BackgroundTexture() {
    m_texture_background.loadFromFile(std::string(ASSETS_PATH) + "background.png");
}