#pragma once

#include "SFML/Graphics.hpp"

class MyTexture {
public:
    MyTexture() = default;
    enum Direction { UP, DOWN, RIGHT, LEFT };
    virtual sf::Texture& get_texture() = 0;
    MyTexture(const MyTexture&) = delete;
    MyTexture& operator=(const MyTexture&) = delete;
    void set_direction(Direction direction) { m_direction = direction; }
protected:
    Direction m_direction = UP;
};

//texture for Pacman
class PacmanTexture : public MyTexture {
public:
    static PacmanTexture& instance() { static PacmanTexture instance; return instance; }
    sf::Texture& get_texture() override;
private:
    PacmanTexture();
    sf::Texture m_texture_up, m_texture_down, m_texture_right, m_texture_left;
};

class PacmanTexture2 : public MyTexture {
public:
    static PacmanTexture2& instance() { static PacmanTexture2 instance; return instance; }
    sf::Texture& get_texture() override;
private:
    PacmanTexture2();
    sf::Texture m_texture_up, m_texture_down, m_texture_right, m_texture_left;
};

//texture for Food
class FoodTexture : public MyTexture {
public:
    static FoodTexture& instance() { static FoodTexture instance; return instance; }
    sf::Texture& get_texture() override { return m_texture_food; }
private:
    FoodTexture();
    sf::Texture m_texture_food;
};

//texture for Enemy
class EnemyTexture : public MyTexture {
public:
    static EnemyTexture& instance() { static EnemyTexture instance; return instance; }
    sf::Texture& get_texture() override { return m_texture_enemy; }
private:
    EnemyTexture();
    sf::Texture m_texture_enemy;
};

class BackgroundTexture : public MyTexture {
public:
    static BackgroundTexture& instance() { static BackgroundTexture instance; return instance; }
    sf::Texture& get_texture() override { return m_texture_background; }
private:
    BackgroundTexture();
    sf::Texture m_texture_background;
};
