#include "Pacman.h"
#include "../../../../config.h"

Pacman::Pacman(MyTexture* texture) : m_ptr_texture(texture) {}

void Pacman::move(Room::Direction direction) {
    m_ptr_room->get_side(direction)->enter(this);
    m_ptr_texture->set_direction(static_cast<MyTexture::Direction>(direction));
}

void Pacman::prepare_for_drawing() {
    m_sprite.setTexture(m_ptr_texture->get_texture());
    m_sprite.setPosition(m_ptr_room->get_position()+sf::Vector2f(-20, -20));
}

std::unique_ptr<IGameEvent> Pacman::visit(Food* ptr_food) {
    if (ptr_food->get_location() != this->get_location()) return {};
    return std::make_unique<DeleteStaticEntity>(ptr_food);
}

std::unique_ptr<IGameEvent> Pacman::visit(Enemy* ptr_enemy) {
    if (ptr_enemy->get_location() != this->get_location()) return {};
    return std::make_unique<LostGame>();
}

void Pacman::draw_into(sf::RenderWindow& window) {
    prepare_for_drawing();
    window.draw(m_sprite);
}