#pragma once

class IGameEvent;

class IObserver {
public:
    virtual ~IObserver() = default;
    virtual void on_notify(const IGameEvent& event) = 0;
};


class ScoreCount : public IObserver {
public:
    ScoreCount(int player) : m_player(player) {}
    void on_notify(const IGameEvent& event) override;
    int get_player_one() const {return m_player_one_food; }
    int get_player_two() const {return m_player_two_food; }

private:
    int m_player;
    int m_player_one_food{0};
    int m_player_two_food{0};
};