#pragma once

#include <iostream>
#include <list>
#include "../Drawable/Maze/IObserver.h"

class GameContext;
class IStaticEntity;

class IGameEvent {
public:
    virtual void handle(GameContext* context) = 0;
    virtual ~IGameEvent() = default;
    void add_observer(IObserver* observer);
protected:
    void notify() const;
private:
    std::vector<IObserver*> m_observers;
};

class WinGame : public IGameEvent {
public:
    void handle(GameContext* context) override;
};

class LostGame : public IGameEvent {
public:
    void handle(GameContext* context) override;
};

class DeleteStaticEntity : public IGameEvent {
public:
    DeleteStaticEntity(IStaticEntity* ptr_entity);
    void handle(GameContext* context) override;
    int get_player_id() const {return m_player_id; }
private:
    IStaticEntity* m_ptr_entity;
    int m_player_id;
};
