#pragma once

#include "IWindowKeeper.h"

#include <memory>
#include <iostream>

class IStateManager;

class IState {
public:
    explicit IState(IStateManager& state_manager) : m_state_manager(state_manager) {}
    virtual ~IState() = default;

    virtual bool do_step() = 0;
protected:
    IStateManager& m_state_manager;
};

class ExitState: public IState {
public:
    explicit ExitState(IStateManager& state_manager) : IState(state_manager) {}
    bool do_step() override {return false; }
};

struct IStateManager {
    virtual void set_next_state(std::unique_ptr<IState>&&  state) = 0;
    virtual ~IStateManager() = default;
};

